<script setup lang="ts">
import vueDatePicker from '@vuepic/vue-datepicker'
import { ref } from 'vue'

const selectedDate = ref({
  start: new Date(),
  end: new Date()
})

const isActive = ref()
const textInputOptions = ref({
  format: 'yyyy/MM/dd'
})

const format = (date: Date) => {
  const day = date.getDate()
  const month = date.getMonth() + 1
  const year = date.getFullYear()

  const nowDate = new Date().toLocaleString().split(' ')[0]
  const selectDate = date.toLocaleString().split(' ')[0]

  return nowDate === selectDate
    ? `${year}/${month}/${day}（今天）`
    : `${year}/${month}/${day}`
}

const emit = defineEmits<{
  (
    event: 'update:modelValue',
    value: { start: Date | null; end: Date | null } | null
  ): void
}>()

function emitValue(): void {
  isActive.value = false
  emit('update:modelValue', selectedDate.value)
}
</script>

<template>
  <div :class="{ active: isActive }" class="datepicker">
    <div class="start-date">
      <vue-date-picker
        v-model="selectedDate.start"
        :clearable="false"
        :enable-time-picker="false"
        :format="format"
        :text-input-options="textInputOptions"
        cancel-text="取消"
        class="dp-input start-dp-input"
        placeholder="年 / 月 / 日"
        position="left"
        select-text="選擇"
        hide-input-icon
        text-input
        @blur="emitValue()"
        @closed="emitValue()"
        @focus="isActive = true"
      />
    </div>

    <span id="range-symbol" class="range-symbol">～</span>

    <div class="end-date">
      <vue-date-picker
        v-model="selectedDate.end"
        :clearable="false"
        :enable-time-picker="false"
        :format="format"
        :text-input-options="textInputOptions"
        cancel-text="取消"
        class="dp-input end-dp-input"
        placeholder="年 / 月 / 日"
        position="left"
        select-text="選擇"
        hide-input-icon
        text-input
        @blur="emitValue()"
        @closed="emitValue()"
        @focus="isActive = true"
      />
    </div>
  </div>
</template>

<style lang="scss" scoped>
%dp-input {
  ::v-deep .dp__input {
    height: 48px;
    padding: 12px 15px;
    background-color: #efefef;
    border: #efefef;
    outline: unset;

    &::placeholder {
      color: #b2b2b2;
      opacity: 1;
    }
  }
}

.datepicker {
  display: flex;
  border-radius: 24px;
  .start-dp-input {
    @extend %dp-input;
    ::v-deep .dp__input {
      padding: 12px 24px;
      border-radius: 24px 0 0 24px;
    }
  }

  .end-dp-input {
    @extend %dp-input;
    ::v-deep .dp__input {
      border-radius: 0 24px 24px 0;
    }
  }

  .range-symbol {
    display: flex;
    align-items: center;
    height: 48px;
    background-color: #efefef;
  }

  &.active {
    border: 1px solid #046db6;

    ::v-deep .dp__input {
      background-color: #fff;
      border-radius: 24px;
    }
    .range-symbol {
      background-color: #fff;
    }
  }
}

::v-deep .dp__outer_menu_wrap {
  .dp__today {
    border-color: #fd832c;
  }
  .dp__active_date {
    background-color: #fd832c;
  }

  .dp__select {
    color: #046db6;
  }
}

.input-slot-image {
  display: flex;
  justify-content: center;
  width: 16px;
  height: 16px;
  margin-right: 24px;
}
</style>
